## mingw-w64-tfel-5.0.0-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
cmake_policy(SET CMP0005 OLD)
cmake_policy(SET CMP0022 NEW)
cmake_policy(SET CMP0026 OLD)
cmake_policy(SET CMP0053 OLD)
cmake_policy(SET CMP0054 NEW)
if(CMAKE_VERSION VERSION_GREATER 3.14.0)
  cmake_policy(SET CMP0083 NEW)  
  include(CheckPIESupported)
  check_pie_supported()
endif(CMAKE_VERSION VERSION_GREATER 3.14.0)

set(TFEL_VERSION_FLAVOUR "" CACHE STRING
  "Append a flavour to the version number")
option(TFEL_APPEND_VERSION
  "append TFEL version number to all libraries, executables and directories" OFF)
option(BUILD_SHARED_LIBS  "enable shared libraries" ON)
if(NOT BUILD_SHARED_LIBS)
  set(CMAKE_POSITION_INDEPENDENT_CODE ON)
  # when BUILD_SHARED_LIBS=OFF then disable option enable-static
  set(enable-static OFF CACHE BOOL "enable additional static libraries" FORCE)
endif()

if(EXISTS "${PROJECT_BINARY_DIR}/conanbuildinfo.cmake")
  include(${PROJECT_BINARY_DIR}/conanbuildinfo.cmake)
  conan_basic_setup(NO_OUTPUT_DIRS)
  set(TFEL_USES_CONAN ON)
endif(EXISTS "${PROJECT_BINARY_DIR}/conanbuildinfo.cmake")

set(CMAKE_CXX_STANDARD 20)
set(CXX_STANDARD_REQUIRED ON)

# tfel specific macros
include(cmake/modules/tfel.cmake)
# some variables for compatibility with autotools
include(cmake/modules/autotools.cmake)

#major and minor version
set(TFEL_DEVELOPMENT_VERSION OFF)
tfel_project(5 0 "0")
set(PACKAGE_BUGREPORT "tfel-contact@cea.fr")

# load the list of rounding modes defined by the IEEE754 standard
include(cmake/modules/ieee754.cmake)

# check for the fenv package
include(CheckIncludeFiles)
check_include_files(fenv.h HAVE_FENV_H)
if(HAVE_FENV_H)
  tfel_add_c_cxx_definitions("HAVE_FENV")
endif(HAVE_FENV_H)

option(enable-include-what-you-use
  "enable include-what-you-use diagnostics" OFF)
if(enable-include-what-you-use)
  find_program(TFEL_IWYU_PATH NAMES include-what-you-use iwyu)
  if(NOT TFEL_IWYU_PATH)
    message(FATAL_ERROR "could not find the program include-what-you-use")
  endif()
endif(enable-include-what-you-use)

find_package(Threads)

if(UNIX)
  if(NOT TFEL_DL_LIBRARY)
    # This is used in mtest tests files
    set(TFEL_LOCAL_LIBRARY_PREFIX "./")
    # Looking for libdl...
    if((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR
	(${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
      find_library(TFEL_DL_LIBRARY
	NAMES dl)
      if(NOT TFEL_DL_LIBRARY)
	MESSAGE(FATAL_ERROR "the libdl library not found. You may want to set the `TFEL_DL_LIBRARY` manually")
      endif(NOT TFEL_DL_LIBRARY)
    else((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR
	(${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
      set(TFEL_DL_LIBRARY "")
    endif((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR
      (${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
  endif(NOT TFEL_DL_LIBRARY)
else(UNIX)
  set(TFEL_LOCAL_LIBRARY_PREFIX "")
  set(TFEL_DL_LIBRARY "")
endif(UNIX)

# adding support for rpath on MacOs X
if(APPLE)
   set(CMAKE_MACOSX_RPATH ON)
   set(CMAKE_SKIP_BUILD_RPATH FALSE)
   set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
   set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
   set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
   list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
   if("${isSystemDir}" STREQUAL "-1")
      set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
   endif()
endif()

# type of architecture
if( CMAKE_SIZEOF_VOID_P EQUAL 8 )
  tfel_add_c_cxx_definitions("TFEL_ARCH64")
else( CMAKE_SIZEOF_VOID_P EQUAL 8 )
  tfel_add_c_cxx_definitions("TFEL_ARCH32")
endif( CMAKE_SIZEOF_VOID_P EQUAL 8 )

#extraction git hash
if(NOT TFEL_GIT_HASH)
execute_process(
  COMMAND git log -1 --format=%h
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  OUTPUT_VARIABLE TFEL_GIT_HASH
  OUTPUT_STRIP_TRAILING_WHITESPACE)
message("Abbreviated commit hash: ${TFEL_GIT_HASH}")
endif(NOT TFEL_GIT_HASH)
tfel_add_c_cxx_definitions("TFEL_GIT_HASH=\"${TFEL_GIT_HASH}\"")
tfel_add_c_cxx_definitions("TFEL_CMAKE_GENERATOR=\"${CMAKE_GENERATOR}\"")

# testing
set(CTEST_CONFIGURATION_TYPE "${JOB_BUILD_CONFIGURATION}")
# (must be placed *before* any add_subdirectory, cmake bug ?)
option(enable-testing "enable tests" ON)
option(enable-mfront-quantity-tests "enable tests of behaviours using quantities (such tests fails on old compilers)" ON)
if(enable-testing)
  enable_testing()
  if(CMAKE_CONFIGURATION_TYPES)
    add_custom_target(check COMMAND
      ${CMAKE_CTEST_COMMAND} -T test -C $<CONFIGURATION>)
  else(CMAKE_CONFIGURATION_TYPES)
    add_custom_target(check COMMAND
      ${CMAKE_CTEST_COMMAND} -T test )
  endif(CMAKE_CONFIGURATION_TYPES)
endif()

option(enable-cppcheck "analyse targets with cppcheck" OFF)
if(enable-cppcheck)
  message(STATUS "cppcheck support enabled")
  set(HAVE_CPPCHECK ON)
  include(cmake/modules/FindCppCheck.cmake)
  include(cmake/modules/CppCheckTargets.cmake)
endif(enable-cppcheck)

option(enable-vera++ "analyse targets with vera++" OFF)
if(enable-vera++)
  message(STATUS "vera++ support enabled")
  find_package(vera++)
  include(${VERA++_USE_FILE})
  if(NOT VERA_ROOT)
    message(fatal "VERA_ROOT is not defined")
  endif(NOT VERA_ROOT)
  add_vera_targets(*.h *.cpp
    RECURSE
    ROOT "${VERA_ROOT}/lib/vera++")
endif(enable-vera++)

# floatting point exceptions (TODO)

# portable-build
option(enable-portable-build "produce binary that can be shared between various machine (same architecture, same gcc version, different processors" OFF)

# madnex
option(enable-madnex "enable madnex file support in mfront (see https://github.com/thelfer/madnex)" OFF)
if(enable-madnex)
  find_package(Madnex REQUIRED)
  set(TFEL_HAVE_MADNEX ON)
endif(enable-madnex)

# fortran (placed before compiler detection)
option(enable-fortran "enable fortran support" OFF)
if(enable-fortran)
  set(HAVE_FORTRAN ON)
  tfel_add_c_cxx_definitions("HAVE_FORTRAN=1")
  enable_language (Fortran)
  message(STATUS "fortran support enabled")
  set(enable-fortran-bindings ON)
else(enable-fortran)
  set(HAVE_FORTRAN OFF)
  message(STATUS "fortran support disabled")
  set(enable-fortran-bindings OFF)
endif(enable-fortran)

#compiler options
include(cmake/modules/compiler.cmake)
if(CMAKE_BUILD_TYPE STREQUAL "Coverage")
  include(cmake/modules/CodeCoverage.cmake)
  SETUP_TARGET_FOR_COVERAGE(coverage ctest coverage)
endif(CMAKE_BUILD_TYPE STREQUAL "Coverage")

#aster
option(enable-aster "build aster interface for mechanical behaviours" OFF)
if(enable-aster)
  message(STATUS "aster support enabled")
  set(HAVE_ASTER ON)
  tfel_add_c_cxx_definitions("HAVE_ASTER=1")
  include(cmake/modules/aster.cmake)
endif(enable-aster)

#abaqus
option(enable-abaqus "build abaqus interface for mechanical behaviours" OFF)
if(enable-abaqus)
  message(STATUS "abaqus support enabled")
  set(HAVE_ABAQUS ON)
  tfel_add_c_cxx_definitions("HAVE_ABAQUS=1")
endif(enable-abaqus)

# LS-DYNA
option(enable-lsdyna "build lsdyna interface for mechanical behaviours" OFF)
if(enable-lsdyna)
  message(STATUS "lsdyna support enabled")
  set(HAVE_LSDYNA ON)
  tfel_add_c_cxx_definitions("HAVE_LSDYNA=1")
endif(enable-lsdyna)

#diana-fea
option(enable-diana-fea "build Diana FEA interface for mechanical behaviours" OFF)
if(enable-diana-fea)
  message(STATUS "Diana FEA support enabled")
  set(HAVE_DIANAFEA ON)
  tfel_add_c_cxx_definitions("HAVE_DIANAFEA=1")
endif(enable-diana-fea)

#calculix
option(enable-calculix "build CalculiX interface for mechanical behaviours" OFF)
if(enable-calculix)
  message(STATUS "CalculiX support enabled")
  set(HAVE_CALCULIX ON)
  tfel_add_c_cxx_definitions("HAVE_CALCULIX=1")
endif(enable-calculix)

#ansys
option(enable-ansys "build ansys interface for mechanical behaviours" OFF)
if(enable-ansys)
  message(STATUS "ansys support enabled")
  set(HAVE_ANSYS ON)
  tfel_add_c_cxx_definitions("HAVE_ANSYS=1")
endif(enable-ansys)

#europlexus
option(enable-europlexus "build europlexus interface for mechanical behaviours" OFF)
if(enable-europlexus)
  message(STATUS "europlexus support enabled")
  set(HAVE_EUROPLEXUS ON)
  tfel_add_c_cxx_definitions("HAVE_EUROPLEXUS=1")
endif(enable-europlexus)

#zmat
option(enable-zmat "build zmat interface for mechanical behaviours" OFF)
if(enable-zmat)
  include(cmake/modules/zset.cmake)
  message(STATUS "zmat support enabled")
  set(HAVE_ZMAT ON)
  tfel_add_c_cxx_definitions("HAVE_ZMAT=1")
endif(enable-zmat)

#cyrano
include(cmake/modules/cyrano.cmake)
option(enable-cyrano "build cyrano interface for mechanical behaviours" OFF)
if(enable-cyrano)
  message(STATUS "cyrano support enabled")
  set(HAVE_CYRANO ON)
  tfel_add_c_cxx_definitions("HAVE_CYRANO=1")
endif(enable-cyrano)

#castem
include(cmake/modules/castem-unix-type.cmake)
option(local-castem-header    "use a local version of castem.h"  OFF)
option(enable-castem-pleiades "use a pleiades version of castem" OFF)
if(local-castem-header)
  tfel_add_c_cxx_definitions("LOCAL_CASTEM_HEADER=1")
  tfel_add_c_cxx_definitions("HAVE_CASTEM=1")
  set(HAVE_CASTEM ON)
  set(LOCAL_CASTEM_HEADER ON)
else(local-castem-header)
  include(cmake/modules/castem.cmake)
endif(local-castem-header)

# comsol
option(enable-comsol "build Comsol interface for mechanical behaviours" OFF)
if(enable-comsol)
  message(STATUS "Comsol support enabled")
  set(HAVE_COMSOL ON)
  tfel_add_c_cxx_definitions("HAVE_COMSOL=1")
endif(enable-comsol)

#gnuplot
include(FindGnuplot)
if(GNUPLOT_FOUND)
  set(HAVE_GNUPLOT ON)
  tfel_add_c_cxx_definitions("HAVE_GNUPLOT=1")
  tfel_add_c_cxx_definitions("GNUPLOT_PATH=\"${GNUPLOT_EXECUTABLE}\"")
  message(STATUS "found gnuplot")
  message(STATUS "gnuplot path ${GNUPLOT_EXECUTABLE}")
else(GNUPLOT_FOUND)
  set(HAVE_GNUPLOT OFF)
endif(GNUPLOT_FOUND)

#python
option(enable-python "enable python support" OFF)
option(enable-python-bindings "enable  python bindings support" OFF)
option(enable-numpy-support
  "enable numpy support. This option has no effect if python bindings are disabled" ON)
option(enable-broken-boost-python-module-visibility-handling
  "workaround a bug in boost python which occurs on FreeBSD+clang. See https://github.com/boostorg/python/issues/173 for details" OFF)

option(python-static-interpreter-workaround
  "a workaround to handle the fact the conda' python interpreter is statically linked, which causes issues on Mac Os. See for details https://github.com/ContinuumIO/anaconda-issues/issues/9078. A proper solution may only appear with CMake 3.15 with the `Python::module` target, see https://gitlab.kitware.com/cmake/cmake/issues/18100. Until this version is widely available, this flag proposes a hack. Use with care." OFF)
 
if(enable-python OR enable-python-bindings)
  find_package(PythonLibs REQUIRED)
  set(HAVE_PYTHON ON)
  tfel_add_c_cxx_definitions("HAVE_PYTHON=1")
  tfel_add_c_cxx_definitions("TFEL_PYTHON_INCLUDES=\"-I${PYTHON_INCLUDE_DIRS}\"")
  get_filename_component(PYTHON_LIBRARY_PATH ${PYTHON_LIBRARIES} PATH)
  get_filename_component(PYTHON_LIBRARY_FULL ${PYTHON_LIBRARIES} NAME)
  string(REGEX REPLACE "lib(.+)\\.(.+)$" "\\1" PYTHON_LIBRARY ${PYTHON_LIBRARY_FULL})
  tfel_add_c_cxx_definitions("TFEL_PYTHON_LIBRARY_PATH=\"${PYTHON_LIBRARY_PATH}\"")
  tfel_add_c_cxx_definitions("TFEL_PYTHON_LIBRARY=\"${PYTHON_LIBRARY}\"")
  if(MSVC)
    tfel_add_c_cxx_definitions("TFEL_PYTHON_LIBS=\"${PYTHON_LIBRARY_PATH}\${PYTHON_LIBRARY}\"")
  else(MSVC)
    tfel_add_c_cxx_definitions("TFEL_PYTHON_LIBS=\"-L${PYTHON_LIBRARY_PATH} -l${PYTHON_LIBRARY}\"")
  endif(MSVC) 
  message(STATUS "found python          ${PYTHONLIBS_VERSION_STRING}")
  message(STATUS "python include path   ${PYTHON_INCLUDE_DIRS}")
  message(STATUS "python libraries path ${PYTHON_LIBRARY_PATH}")
  message(STATUS "python library        ${PYTHON_LIBRARY}")
  string(REGEX REPLACE "[-a-z+]+.*$" "" PYTHONLIBS_VERSION_CLEANED "${PYTHONLIBS_VERSION_STRING}")
  find_package(PythonInterp ${PYTHONLIBS_VERSION_CLEANED} REQUIRED)
  message(STATUS "python interpreter    ${PYTHON_EXECUTABLE}")
  if(NOT TFEL_PYTHON_SITE_PACKAGES_DIR)
    if(WIN32)
      set(TFEL_PYTHON_SITE_PACKAGES_DIR "bin/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages")

=== docs/release-notes-2.0.4/CMakeLists.txt ===
if(HAVE_LATEX)
  configure_file(tfel-2.0.4.tex.in
    tfel-2.0.4.tex @ONLY)

  ADD_CUSTOM_COMMAND(
    OUTPUT    tfel-2.0.4.pdf
    DEPENDS    ${CMAKE_CURRENT_SOURCE_DIR}/tfel-2.0.4.tex.in
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${PDFLATEX_COMPILER}
    ARGS      -interaction=batchmode tfel-2.0.4.tex
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${PDFLATEX_COMPILER}
    ARGS      -interaction=batchmode tfel-2.0.4.tex
    # COMMAND   BSTINPUTS=@abs_top_srcdir@/docs/tex/texmf/bibtex ${BIBTEX_COMPILER}
    # ARGS      -terse tfel-2.0.4
    # COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${PDFLATEX_COMPILER}
    # ARGS      -interaction=batchmode tfel-2.0.4.tex
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${PDFLATEX_COMPILER}
    ARGS      -interaction=batchmode tfel-2.0.4.tex
    COMMENT   "tfel-2.0.4.pdf")

  add_custom_target(tfel-2.0.4-doc-pdf ALL DEPENDS tfel-2.0.4.pdf)
  add_dependencies(doc-pdf
    tfel-2.0.4-doc-pdf)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tfel-2.0.4.pdf
      DESTINATION share/doc/tfel-${TFEL_SUFFIX}/references
      COMPONENT docs)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tfel-2.0.4.pdf
      DESTINATION share/doc/tfel-${TFEL_SUFFIX}/web/documents/tfel
      COMPONENT website)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tfel-2.0.4.pdf
      DESTINATION share/doc/tfel/references
      COMPONENT docs)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tfel-2.0.4.pdf
      DESTINATION share/doc/tfel/web/documents/tfel
      COMPONENT website)
  endif(TFEL_APPEND_SUFFIX)
endif(HAVE_LATEX)

=== docs/web/CMakeLists.txt ===
macro(pandoc_html file)
  ADD_CUSTOM_COMMAND(
    OUTPUT    ${CMAKE_CURRENT_BINARY_DIR}/${file}.html
    DEPENDS   ${CMAKE_CURRENT_SOURCE_DIR}/${file}.md
    DEPENDS   ${CMAKE_CURRENT_SOURCE_DIR}/mfront-template.html
    DEPENDS   ${CMAKE_CURRENT_SOURCE_DIR}/css/main.css
    COMMAND   ${PANDOC}
    ARGS      -f markdown-markdown_in_html_blocks+tex_math_single_backslash+grid_tables
    ARGS      --filter pandoc-crossref -M crossrefYaml=${CMAKE_CURRENT_SOURCE_DIR}/pandoc-crossref.yaml
    ARGS      --bibliography=${CMAKE_CURRENT_SOURCE_DIR}/bibliography.bib --citeproc
    ARGS      --template=${CMAKE_CURRENT_SOURCE_DIR}/mfront-template.html
    ARGS      --csl=${CMAKE_CURRENT_SOURCE_DIR}/iso690-numeric-en.csl
    ARGS      --mathjax
    ARGS      --highlight-style=tango
    ARGS      --email-obfuscation=javascript
    ARGS       --default-image-extension=svg
    ARGS      ${ARGN}
    ARGS      ${CMAKE_CURRENT_SOURCE_DIR}/${file}.md -o ${file}.html)
  add_custom_target(${file}-html ALL DEPENDS ${file}.html)
  add_dependencies(website ${file}-html)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${file}.html
      DESTINATION share/doc/tfel-${TFEL_SUFFIX}/web
      COMPONENT website)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${file}.html
      DESTINATION share/doc/tfel/web
      COMPONENT website)
  endif(TFEL_APPEND_SUFFIX)
endmacro(pandoc_html)

add_custom_target(website)
add_dependencies(doc website)

pandoc_html(index "-c css/slideshow.css")
pandoc_html(initializers)
pandoc_html(post-processings)
pandoc_html(associated-projects "--toc")
pandoc_html(mfront-types "--toc")
pandoc_html(search)
pandoc_html(faq "--toc")
pandoc_html(getting-started "--toc")
pandoc_html(interfaces)
pandoc_html(install "--toc" "--number-sections")
pandoc_html(install-freebsd "-c css/slideshow.css")
pandoc_html(install-windows-msys)
pandoc_html(install-windows-Cast3M2017 "--toc")
pandoc_html(install-windows-VisualStudio)
pandoc_html(packages)
pandoc_html(about)
pandoc_html(svn)
pandoc_html(devel)
pandoc_html(libraries_usage  "--toc" "--toc-depth=3")
pandoc_html(mtest)
pandoc_html(mtest-python "--toc" "--toc-depth=3")
pandoc_html(tutorial "--toc" "--toc-depth=3")
pandoc_html(tutorial-spanish  "--toc" "--toc-depth=3")
pandoc_html(benchmark)
pandoc_html(news "-c css/slideshow.css")
pandoc_html(castem)
pandoc_html(castem-fr)
pandoc_html(amitex "-c css/slideshow.css")
pandoc_html(cyrano "--toc" "--toc-depth=1"  "--number-sections")
pandoc_html(aster "--toc" "--toc-depth=1"  "-c css/slideshow.css")
pandoc_html(abaqus "-c css/slideshow.css")
pandoc_html(ansys "-c css/slideshow.css")
pandoc_html(calculix "-c css/slideshow.css")
pandoc_html(zmat)
pandoc_html(epx "-c css/slideshow.css")
pandoc_html(documentations)
pandoc_html(gallery  "--toc")
pandoc_html(glossary)
pandoc_html(material-properties "--toc" "--toc-depth=3" "--number-sections")
pandoc_html(behaviours)
pandoc_html(implicit-dsl "--toc" "--toc-depth=3"  "--number-sections")
pandoc_html(models)
pandoc_html(parameters "--toc" "--toc-depth=3"  "--number-sections")
pandoc_html(publications)
pandoc_html(release-notes "--toc" "--toc-depth=1")
pandoc_html(mfront-query "--toc" "--toc-depth=2")
pandoc_html(compiling-mfront-shared-libraries "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(madnex "--toc" "--toc-depth=2")
pandoc_html(math "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(mfm)
pandoc_html(mfm-test-generator)
pandoc_html(mfront-doc)
pandoc_html(tfel-material "--toc" "--toc-depth=2")
pandoc_html(tfel-math "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(tfel-math-data-interpolation "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(tfel-check "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(mfront-python "--toc" "--toc-depth=3")
pandoc_html(Norton-web)
pandoc_html(Norton-full)
pandoc_html(coverity-scan)
pandoc_html(drucker "--toc")
pandoc_html(drucker-prager-cap "--toc")
pandoc_html(hosford "--toc")
pandoc_html(barlat-yld2004 "--toc")
pandoc_html(greenplasticity "--toc")
pandoc_html(hyperelasticity "--toc")
pandoc_html(FeFpImplicitPlasticity "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(signorini "--toc" "--toc-depth=2" "-c css/slideshow.css")
pandoc_html(ogden "--toc" "--toc-depth=2")
pandoc_html(iwan "--toc" "--toc-depth=2")
pandoc_html(hyperviscoelasticity "--toc" "--toc-depth=2")
pandoc_html(IsotropicLinearHardeningPlasticity "--toc" "--toc-depth=2")
pandoc_html(orthotropiclinearhardeningplasticity "--toc" "--toc-depth=2")
pandoc_html(physical-constants)
pandoc_html(isotropicplasticityamstrongfrederickinematichardening "--toc" "--toc-depth=2")
pandoc_html(singlecrystal "--toc" "--toc-depth=2")
pandoc_html(finitestrainsinglecrystal "--toc" "--toc-depth=2")
pandoc_html(finitestrainsinglecrystal-huang "--toc" "--toc-depth=2")
pandoc_html(phasefield "--toc" "--toc-depth=2")
pandoc_html(release-notes-2.0.5 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0   "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.1 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.2 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.3 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.4 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.5 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.6 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.7 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.8 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.9 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.10 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.11 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.12 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.13 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.0.14 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1   "--toc" "--toc-depth=2" "--number-sections" "-c css/slideshow.css")
pandoc_html(release-notes-3.1.1 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.2 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.3 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.4 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.5 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.6 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.7 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.8 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.9 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.10 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.11 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.12 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.13 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.1.14 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2   "--toc" "--toc-depth=2" "--number-sections" "-c css/slideshow.css")
pandoc_html(release-notes-3.2.1 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.2 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.3 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.4 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.5 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.6 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.7 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.8 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.9 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.10 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.2.11 "--toc" "--toc-depth=2")
pandoc_html(release-notes-3.3   "--toc" "--toc-depth=2" "--number-sections" "-c css/slideshow.css")
pandoc_html(release-notes-3.3.1   "--toc" "--toc-depth=2" "--number-sections" "-c css/slideshow.css")
pandoc_html(release-notes-3.3.2   "--toc" "--toc-depth=2" "--number-sections" "-c css/slideshow.css")
pandoc_html(release-notes-3.3.3)
pandoc_html(release-notes-3.3.4   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.3.5   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.3.6   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.1   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.2   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.3   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.4   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.5   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.6   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-3.4.7   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.0   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.0.1 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.0.2 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.0.3 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.0.4 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.1   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.1.1 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.1.2 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.1.3 "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.2   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.2.1   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-4.2.2   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(release-notes-5.0   "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(theory  "--toc" "--toc-depth=2")
pandoc_html(tensors "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(tfel-physical-constants "--toc" "--toc-depth=2")
pandoc_html(tfel-python "--toc" "--toc-depth=3")
pandoc_html(generic-material-property-interface "--toc")
pandoc_html(generic-behaviours-interface "--toc" "--toc-depth=3")
pandoc_html(sovs "--toc" "--toc-depth=2")
pandoc_html(unicode "--toc" "--toc-depth=2")
pandoc_html(RambergOsgoodNonLinearElasticity "--toc" "--toc-depth=2")
pandoc_html(MericCailletaudSingleCrystalPlasticity  "--toc" "--toc-depth=2")
pandoc_html(MohrCoulomb "--toc" "--toc-depth=2")
pandoc_html(FichantLaBorderieDamageBehaviour "--toc" "--toc-depth=2")
pandoc_html(LoadInducedThermalStrainBehaviourTorelli2018  "--toc" "--toc-depth=2")
pandoc_html(FichantLaBorderieDamageAndTorelliLoadInducedStrainBehaviour   "--toc" "--toc-depth=2")
pandoc_html(FischerBurmeister "--toc" "--toc-depth=2")
pandoc_html(TFELSystem "--toc" "--toc-depth=2")
pandoc_html(BehaviourBricks "--toc" "--toc-depth=2")
pandoc_html(DDIF2Brick "--toc" "--toc-depth=2")
pandoc_html(StandardElastoViscoPlasticityBrick "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(StandardElastoViscoPlasticityBrick-PorousPlasticity "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(ExtendingStandardElastoViscoPlasticityBrick-StressCriterion "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(ExtendingStandardElastoViscoPlasticityBrick-PorousStressCriterion "--toc" "--toc-depth=2"  "--number-sections")
pandoc_html(HookeStressPotential "--toc" "--toc-depth=2")
pandoc_html(DDIF2StressPotential "--toc" "--toc-depth=2")
pandoc_html(ExplicitBerveillerZaouiPolyCrystals "--toc" "--toc-depth=2")
pandoc_html(ImplicitBerveillerZaouiPolyCrystals "--toc" "--toc-depth=2" "--number-sections")
pandoc_html(Burger_EDF_CIWAP_2021 "--toc" "--toc-depth=2")

# mfront keywords

pandoc_html(DefaultCZM-keywords "--toc" "--toc-depth=1")
pandoc_html(DefaultFiniteStrain-keywords "--toc" "--toc-depth=1")
pandoc_html(DefaultGenericBehaviour-keywords "--toc" "--toc-depth=1")
pandoc_html(Default-keywords "--toc" "--toc-depth=1")
pandoc_html(DefaultModel-keywords "--toc" "--toc-depth=1")
pandoc_html(ImplicitCZM-keywords "--toc" "--toc-depth=1")
pandoc_html(ImplicitFiniteStrain-keywords "--toc" "--toc-depth=1")

=== mfront-query/include/CMakeLists.txt ===
install_mfront_header(MFront QueryUtilities.hxx)
install_mfront_header(MFront QueryHandlerBase.hxx)
install_mfront_header(MFront MaterialPropertyQuery.hxx)
install_mfront_header(MFront BehaviourQuery.hxx)
install_mfront_header(MFront ModelQuery.hxx)

=== mfront-query/src/CMakeLists.txt ===
# mfront-query
add_executable(mfront-query mfront-query.cxx
  QueryUtilities.cxx
  QueryHandlerBase.cxx
  MaterialPropertyQuery.cxx
  BehaviourQuery.cxx
  ModelQuery.cxx)
set_property(TARGET mfront-query PROPERTY POSITION_INDEPENDENT_CODE TRUE)
target_include_directories(mfront-query 
  PRIVATE "${PROJECT_SOURCE_DIR}/mfront-query/include")
target_link_libraries(mfront-query
  PUBLIC
  tfel::TFELMFront
  tfel::MFrontLogStream
  tfel::TFELSystem
  tfel::TFELUtilities)
if(TFEL_APPEND_SUFFIX)
  set_target_properties(mfront-query
    PROPERTIES OUTPUT_NAME "mfront-query-${TFEL_SUFFIX}")
endif(TFEL_APPEND_SUFFIX)

if(TFEL_HAVE_MADNEX)
  target_compile_definitions(mfront-query
    PUBLIC MFRONT_QUERY_HAVE_MADNEX)
  target_link_libraries(mfront-query
    PRIVATE madnex::Madnex)
endif(TFEL_HAVE_MADNEX)

install(TARGETS mfront-query DESTINATION bin
  COMPONENT mfront)

=== mfront/tests/CMakeLists.txt ===
add_subdirectory(properties)
add_subdirectory(behaviours)
add_subdirectory(models)
add_subdirectory(unit-tests)

=== src/UnicodeSupport/CMakeLists.txt ===
tfel_library(TFELUnicodeSupport UnicodeSupport.cxx)
target_include_directories(TFELUnicodeSupport
   PUBLIC 
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
   $<INSTALL_INTERFACE:include>)
if(enable-static)
   target_include_directories(TFELUnicodeSupport-static
     PUBLIC 
     $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
     $<INSTALL_INTERFACE:include>)
endif(enable-static)

=== tests/Material/CMakeLists.txt ===
# a simple macro
macro(tests_material test_arg)
  add_executable(${test_arg} EXCLUDE_FROM_ALL ${test_arg}.cxx)
  add_test(NAME ${test_arg} COMMAND ${test_arg})
  add_dependencies(check ${test_arg})
  if((CMAKE_HOST_WIN32) AND (NOT MSYS))
    set_property(TEST ${test_arg}
  	         PROPERTY ENVIRONMENT "PATH=$<TARGET_FILE_DIR:TFELMaterial>\;$<TARGET_FILE_DIR:TFELNUMODIS>\;$<TARGET_FILE_DIR:TFELMath>\;$<TARGET_FILE_DIR:TFELUtilities>\;$<TARGET_FILE_DIR:TFELException>\;$<TARGET_FILE_DIR:TFELTests>\;$ENV{PATH}")
  endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
  target_link_libraries(${test_arg} TFELMaterial TFELMath
    TFELUtilities TFELException TFELTests)
endmacro(tests_material)

tests_material(EshelbyBasedHomogenization)
tests_material(Eshelby)
tests_material(Lame)
tests_material(boundsCheck)
tests_material(OrthotropicAxesConventionTest)
tests_material(AbaqusTangentOperator)
tests_material(AbaqusTangentOperator2)
tests_material(FiniteStrainBehaviourTangentOperator)
tests_material(FiniteStrainBehaviourTangentOperator2)
tests_material(FiniteStrainBehaviourTangentOperator3)
tests_material(FiniteStrainBehaviourTangentOperator4)
tests_material(FiniteStrainBehaviourTangentOperator5)
tests_material(FiniteStrainBehaviourTangentOperator6)
tests_material(FiniteStrainBehaviourTangentOperator7)
tests_material(FiniteStrainBehaviourTangentOperator8)
tests_material(FiniteStrainBehaviourTangentOperator9)
tests_material(FiniteStrainBehaviourTangentOperator10)
tests_material(FiniteStrainBehaviourTangentOperator11)
tests_material(FiniteStrainBehaviourTangentOperator12)
tests_material(FiniteStrainBehaviourTangentOperator13)
tests_material(FiniteStrainBehaviourTangentOperator14)
tests_material(LogarithmicStrainHandlerTest)
tests_material(Hyperelasticity)
tests_material(Ogden)
tests_material(IsotropicPlasticityTest)
tests_material(OrthotropicPlasticityTest)
tests_material(SlipSystemsDescriptionTest)
tests_material(HosfordSecondDerivativeTest)
tests_material(BarlatSecondDerivativeTest)
tests_material(BarlatSecondDerivativeTest2)
tests_material(IsotropicCazacuYieldTest)
tests_material(LogarithmicStrainComputeAxialStrainIncrementElasticPredictionTest)
tests_material(InverseLangevinFunctionTest)

=== tests/Math/CMakeLists.txt ===
add_subdirectory(ExpressionTemplates)
add_subdirectory(RungeKutta)
add_subdirectory(stensor)
add_subdirectory(tensor)
add_subdirectory(st2tost2)
add_subdirectory(t2tost2)
add_subdirectory(st2tot2)
add_subdirectory(t2tot2)
if(enable-cadna)
  add_subdirectory(cadna)
endif(enable-cadna)

# a simple macro
macro(tests_math test_arg)
  add_executable(${test_arg} EXCLUDE_FROM_ALL ${test_arg}.cxx)
  target_include_directories(${test_arg}
    PRIVATE ${PROJECT_SOURCE_DIR}/tests/Math/include/)
  target_link_libraries(${test_arg}
    TFELMath TFELUtilities TFELException TFELTests)
  add_test(NAME ${test_arg} COMMAND ${test_arg})
  add_dependencies(check ${test_arg})
  if((CMAKE_HOST_WIN32) AND (NOT MSYS))
    set_property(TEST ${test_arg}
  	         PROPERTY ENVIRONMENT "PATH=$<TARGET_FILE_DIR:TFELMath>\;$<TARGET_FILE_DIR:TFELUtilities>\;$<TARGET_FILE_DIR:TFELException>\;$<TARGET_FILE_DIR:TFELTests>\;$<TARGET_FILE_DIR:TFELUnicodeSupport>\;$ENV{PATH}")
  endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
endmacro(tests_math)

macro(tests_math2 test_arg)
  add_executable(${test_arg} EXCLUDE_FROM_ALL ${test_arg}.cxx)
  add_test(NAME ${test_arg} COMMAND ${test_arg})
  add_dependencies(check ${test_arg})
  if((CMAKE_HOST_WIN32) AND (NOT MSYS))
    set_property(TEST ${test_arg}
  	         PROPERTY ENVIRONMENT "PATH=$<TARGET_FILE_DIR:TFELMathKriging>\;$<TARGET_FILE_DIR:TFELMath>\;$<TARGET_FILE_DIR:TFELUtilities>\;$<TARGET_FILE_DIR:TFELException>\;$<TARGET_FILE_DIR:TFELTests>\;$<TARGET_FILE_DIR:TFELUnicodeSupport>\;$ENV{PATH}")
  endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
  target_link_libraries(${test_arg} TFELMathKriging TFELMath TFELUtilities TFELException TFELTests)
endmacro(tests_math2)

macro(tests_math3 test_arg)
  add_executable(${test_arg} EXCLUDE_FROM_ALL ${test_arg}.cxx)
  add_test(NAME ${test_arg} COMMAND ${test_arg})
  add_dependencies(check ${test_arg})
  if((CMAKE_HOST_WIN32) AND (NOT MSYS))
    set_property(TEST ${test_arg}
  	         PROPERTY ENVIRONMENT "PATH=$<TARGET_FILE_DIR:TFELMathKriging>\;$<TARGET_FILE_DIR:TFELMathParser>\;$<TARGET_FILE_DIR:TFELMath>\;$<TARGET_FILE_DIR:TFELUtilities>\;$<TARGET_FILE_DIR:TFELException>\;$<TARGET_FILE_DIR:TFELTests>\;$<TARGET_FILE_DIR:TFELUnicodeSupport>\;$ENV{PATH}")
  endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
  target_link_libraries(${test_arg} TFELMathParser TFELMathKriging TFELMath TFELUtilities TFELException TFELTests)
endmacro(tests_math3)

macro(tests_math4 test_arg)
  add_executable(${test_arg} EXCLUDE_FROM_ALL ${test_arg}.cxx)
  add_test(NAME ${test_arg} COMMAND ${test_arg})
  add_dependencies(check ${test_arg})
  if((CMAKE_HOST_WIN32) AND (NOT MSYS))
    set_property(TEST ${test_arg}
  	         PROPERTY ENVIRONMENT "PATH=$<TARGET_FILE_DIR:TFELMathCubicSpline>\;$<TARGET_FILE_DIR:TFELMath>\;$<TARGET_FILE_DIR:TFELUtilities>\;$<TARGET_FILE_DIR:TFELException>\;$<TARGET_FILE_DIR:TFELTests>\;$<TARGET_FILE_DIR:TFELUnicodeSupport>\;$ENV{PATH}")
  endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
  target_link_libraries(${test_arg} TFELMathCubicSpline TFELMath TFELUtilities TFELException TFELTests)
endmacro(tests_math4)

tests_math(IndexingPoliciesTest)
tests_math(view)
tests_math(power)
tests_math(CubicRoots)
tests_math(promote)
tests_math(derivative_type)
tests_math(derivative_view)
tests_math(hill)
tests_math(qt)
tests_math(qt2)
tests_math(qt3)
tests_math(qt4)
tests_math(conj)
tests_math(lu)
tests_math(lu2)
tests_math(lu3)
tests_math(invert)
tests_math(invert2)
tests_math(tinymatrixsolve)
tests_math(tinymatrixsolve2)
tests_math(qr)
tests_math(newton_raphson)
tests_math(powell_dog_leg_newton_raphson)
tests_math(solve)
tests_math(fsarray)
tests_math(runtime_array)
tests_math(tmatrix)
tests_math(tmatrix1)
tests_math(tmatrix2)
tests_math(tmatrix4)
tests_math(tmatrix5)
tests_math(tmatrix6)
tests_math(tmatrix7)
tests_math(tvector)
tests_math(tvector2)
tests_math(tvector3)
tests_math(tvector4)
tests_math(tvector5)
tests_math(tvector6)
tests_math(tvector7)
tests_math(VectorResultType)
tests_math(broyden)
tests_math(broyden2)
tests_math(TinyVectorOfStensorFromTinyVectorView)
tests_math(TinyVectorOfTinyVectorFromTinyVectorView)
tests_math(discretization1D)
tests_math(levenberg-marquardt)
tests_math(levenberg-marquardt2)
tests_math(levenberg-marquardt3)
tests_math(levenberg-marquardt5)
tests_math(CorotationnalCauchyStressToSecondPioloKirchhoffStressTest)
tests_math(StridedRandomAccessIteratorTest)
tests_math(DifferenceRandomAccessIteratorTest)
tests_math(IEEE754Test)
tests_math(ScalarNewtonRaphsonTest)
tests_math(BissectionAlgorithmTest)
tests_math(FixedSizeArrayDerivativeTest)
tests_math(ComputeNumericalDerivativeTest)
tests_math(LinearInterpolationTest)
tests_math(CubicSplineInterpolationTest)
tests_math(matrix)
tests_math(types)

tests_math3(levenberg-marquardt4)

tests_math2(krigeage)
tests_math2(krigeage1D)
tests_math2(krigeage2D)

tests_math3(parser)
tests_math3(parser2)
tests_math3(parser3)
tests_math3(parser4)
tests_math3(parser5)
tests_math3(parser6)
tests_math3(parser7)
tests_math3(parser8)
tests_math3(parser9)
tests_math3(parser10)
tests_math3(parser11)
tests_math3(parser12)
tests_math3(integerparser)

tests_math4(CubicSplineTest)

tests_math4(TensorProductCheck)

=== tests/System/CMakeLists.txt ===
# a simple macro
macro(tests_system test_arg)
  add_executable(${test_arg} EXCLUDE_FROM_ALL ${test_arg}.cxx)
  add_test(NAME ${test_arg} COMMAND ${test_arg})
  add_dependencies(check ${test_arg})
  if((CMAKE_HOST_WIN32) AND (NOT MSYS))
    set_property(TEST ${test_arg}
  	         PROPERTY ENVIRONMENT "PATH=$<TARGET_FILE_DIR:TFELSystem>\;$<TARGET_FILE_DIR:TFELException>\;$<TARGET_FILE_DIR:TFELTests>\;$ENV{PATH}")
  endif((CMAKE_HOST_WIN32) AND (NOT MSYS))
  target_link_libraries(${test_arg} TFELSystem TFELException TFELTests)
endmacro(tests_system)

if(UNIX)
tests_system(process_test_target)
tests_system(process)
tests_system(rwstream)
tests_system(binary_write)
endif(UNIX)

if((NOT i586-mingw32msvc_COMPILER) AND (NOT i686-w64-mingw32_COMPILER))
  tests_system(ThreadPoolTest)
  tests_system(ThreadPoolTest2)
endif((NOT i586-mingw32msvc_COMPILER) AND (NOT i686-w64-mingw32_COMPILER))

=== tfel-config/include/CMakeLists.txt ===
configure_file(${PROJECT_SOURCE_DIR}/tfel-config/include/tfel-config.hxx.in
               ${PROJECT_BINARY_DIR}/tfel-config/include/tfel-config.hxx)

=== bindings/python/tests/CMakeLists.txt ===
function(test_pymfront test)
  configure_file(pymfront${test}.py.in
    pymfront${test}.py @ONLY)
  add_test(NAME pymfront${test}_py
    COMMAND ${PYTHON_EXECUTABLE} pymfront${test}.py)
  if(CMAKE_CONFIGURATION_TYPES)
    set_tests_properties(pymfront${test}_py
      PROPERTIES ENVIRONMENT "PYTHONPATH=${PROJECT_BINARY_DIR}/bindings/python;$<TARGET_FILE_DIR:py_std__stl_vector>;$<TARGET_FILE_DIR:py_tfel_tests;$<TARGET_FILE_DIR:py_mfront__mfront>")
  else(CMAKE_CONFIGURATION_TYPES)
    set_tests_properties(pymfront${test}_py
      PROPERTIES ENVIRONMENT "PYTHONPATH=${PROJECT_BINARY_DIR}/bindings/python")
  endif(CMAKE_CONFIGURATION_TYPES)
endfunction(test_pymfront)

function(test_pymfront_mp interface library function)
  add_test(NAME pymfront_material_properties_${interface}_py
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/material-properties.py)
  if(CMAKE_CONFIGURATION_TYPES)
    set_property(TEST pymfront_material_properties_${interface}_py
      PROPERTY ENVIRONMENT
      PYTHONPATH=${PROJECT_BINARY_DIR}/bindings/python;$<TARGET_FILE_DIR:py_std__stl_vector>;$<TARGET_FILE_DIR:py_tfel_tests;$<TARGET_FILE_DIR:py_mfront__mfront>
      MFRONT_MATERIAL_PROPERTY_LIBRARY=${library}
      MFRONT_MATERIAL_PROPERTY_FUNCTION=${function})
  else(CMAKE_CONFIGURATION_TYPES)
    set_property(TEST pymfront_material_properties_${interface}_py
      PROPERTY ENVIRONMENT
      PYTHONPATH=${PROJECT_BINARY_DIR}/bindings/python
      MFRONT_MATERIAL_PROPERTY_LIBRARY=${library}
      MFRONT_MATERIAL_PROPERTY_FUNCTION=${function})      
  endif(CMAKE_CONFIGURATION_TYPES)
endfunction(test_pymfront_mp)

function(test_pymtest_bv file library)
  add_test(NAME pymtest_behaviours_${file}_py
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/${file}.py)
  if(CMAKE_CONFIGURATION_TYPES)
    set_property(TEST pymtest_behaviours_${file}_py
      PROPERTY ENVIRONMENT
      PYTHONPATH=${PROJECT_BINARY_DIR}/bindings/python;$<TARGET_FILE_DIR:py_std__stl_vector>;$<TARGET_FILE_DIR:py_tfel_tests;$<TARGET_FILE_DIR:py_mtest__mtest>
      MTEST_BEHAVIOUR_LIBRARY=${library})
  else(CMAKE_CONFIGURATION_TYPES)
    set_property(TEST pymtest_behaviours_${file}_py
      PROPERTY ENVIRONMENT
      PYTHONPATH=${PROJECT_BINARY_DIR}/bindings/python
      MTEST_BEHAVIOUR_LIBRARY=${library})      
  endif(CMAKE_CONFIGURATION_TYPES)
endfunction(test_pymtest_bv)

if(HAVE_ASTER)
  test_pymfront(test1)
endif(HAVE_ASTER)
test_pymfront(test2)
test_pymfront(test3)

test_pymfront_mp("generic" "$<TARGET_FILE:MFrontMaterialProperties-generic>" "VanadiumAlloy_YoungModulus_SRMA")
test_pymfront_mp("c" "$<TARGET_FILE:MFrontMaterialProperties>" "VanadiumAlloy_YoungModulus_SRMA")
test_pymfront_mp("cxx" "$<TARGET_FILE:MFrontMaterialProperties-cxx>" "VanadiumAlloy_YoungModulus_SRMA")
if(HAVE_FORTRAN)
 test_pymfront_mp("fortran" "$<TARGET_FILE:MFrontMaterialProperties-fortran>" "VanadiumAlloy_YoungModulus_SRMA")
endif(HAVE_FORTRAN)
if(HAVE_CASTEM)
 test_pymfront_mp("castem" "$<TARGET_FILE:MFrontMaterialProperties-castem>" "VanadiumAlloy_YoungModulus_SRMA")
endif(HAVE_CASTEM)

test_pymtest_bv(behaviour-constructors "$<TARGET_FILE:MFrontGenericBehaviours>")
test_pymtest_bv(small-strain-tridimensional-behaviour-wrapper "$<TARGET_FILE:MFrontGenericBehaviours>")

=== PKGBUILD ===
# Maintainer: Rafał Brzegowy <rafal.brzegowy@yahoo.com>

_realname=tfel
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.0.0
pkgrel=1
pkgdesc='MFront: a code generation tool dedicated to material knowledge (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
provides=("${MINGW_PACKAGE_PREFIX}-mfront")
depends=("${MINGW_PACKAGE_PREFIX}-gnuplot"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran") )
makedepends=("unzip"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-cc"
             $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-fortran") )
license=('spdx:GPL-3.0-or-later')
url='https://tfel.sourceforge.io/'
source=(https://github.com/thelfer/${_realname}/archive/TFEL-${pkgver}.zip
        "fix_zmat.patch::https://github.com/thelfer/tfel/commit/3f42cd05b256deeb80e795b9c35f11dca35b7e39.patch")
sha256sums=('02a0aa6e60e0ae4dd6103171462f394197e3fdb8a96a295c313a8d853966acda'
            'd0d958d54e43c82fc94e4e9140d52520cfd07c8186df6f7d683d3af723bda9c4')
noextract=("TFEL-${pkgver}.zip") # bsdtar could not unpack this archive

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Np1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  unzip -oq TFEL-${pkgver}.zip -d ${srcdir}
  
  cd ${_realname}-TFEL-${pkgver}
  apply_patch_with_msg \
    fix_zmat.patch
}

build() {
  [[ -d "${srcdir}/build-${MSYSTEM}" ]] && rm -rf "${srcdir}/build-${MSYSTEM}"
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a extra_conf
  case ${MSYSTEM} in
    CLANG*)
      extra_conf+=("-Denable-fortran=OFF");;
    *)
      extra_conf+=("-Denable-fortran=ON");;
  esac

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_BUILD_TYPE=Release \
      -Denable-python=OFF \
      -Denable-python-bindings=OFF \
      -Denable-aster=ON \
      -Denable-abaqus=ON \
      -Denable-ansys=ON \
      -Denable-europlexus=ON \
      -Denable-zmat=ON \
      -Denable-cyrano=ON \
      -Denable-calculix=ON \
      -Denable-comsol=ON \
      -Denable-diana-fea=ON \
      -Denable-lsdyna=ON \
      -Denable-cxx-17=ON \
      -Denable-portable-build=ON \
      -Denable-reference-doc=OFF \
      ${extra_conf} \
      ../${_realname}-TFEL-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR=${pkgdir} cmake --build . --target install
  install -Dm644 ${srcdir}/${_realname}-TFEL-${pkgver}/LICENCE-GNU-GPL ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}

# vim: ts=2 sw=2 et:
